var Page = require("./Page.js").Page;
var moment = require('moment');

module.exports = function() {
  var tr = this;
  tr.fancyname = "transformer tags";
  tr.linksPerPage = 6;
  tr.pre = function(cb, list) {
    var tags = new Array();
    var tagPages = {};
    list.forEach(function(article) {
      if(article.metadata.tags)
      article.metadata.tags.forEach(function(tag) {
        if(tags.map(function(e) { return e.url; }).indexOf(tag.url) < 0)
          tags.push(tag)
        if(tagPages[tag.url] == undefined) tagPages[tag.url] = new Array();
        tagPages[tag.url].push(article)
      })
    });

    var generateTagPages = function(file, pageList) {
      var p = new Page();
      p.type = "redirect";
      p.file = file;
      p.content = file+"/1";
      list.addPage(p);

      pageList.sort(function (a, b) {
        var rhs = a.metadata.date.creation;
        var lhs = b.metadata.date.creation;
        return lhs > rhs ? 1 : lhs < rhs ? -1 : 0;
      })
      var c = 0;
      var p = 0;
      var tagPage;
      var prevurl;
      var prevpage;
      var firstpage;
      var lastpage;
      tagPageList = [];
      pageList.forEach(function(page) {
        if(c == 0) {
          p++;
          if(tagPage !== undefined) {
            tagPage.metadata.nexturl = file+"/"+p;
            list.addPage(tagPage);
            tagPageList.push(tagPage);
          }
          tagPage = new Page();
          if(firstpage === undefined) firstpage = tagPage;
          lastpage = tagPage;

          tagPage.file = file+"/"+p;
          tagPage.type = "tag";
          tagPage.metadata.firstpage = firstpage;
          tagPage.metadata.prevpage = prevpage;
          tagPage.metadata.prevurl = prevurl;
          tagPage.metadata.thispage = tagPage;
          tagPage.metadata.pagenumber = p;
          
          tagPage.content = new Array();
          if(prevpage !== undefined)
            prevpage.metadata.nextpage = tagPage;
          prevurl = tagPage.file;
          prevpage = tagPage;
        }
        tagPage.content.push(page);

        c++;
        c %= tr.linksPerPage;
      });
      list.addPage(tagPage);
      tagPageList.push(tagPage);
      tagPageList.forEach(function(tagPage) {
        tagPage.metadata.lastpage = lastpage;
      });
    }
    

    tags.forEach(function(tag) {
      generateTagPages("tag/"+tag.url, tagPages[tag.url])
    })
    cb();
  }
}

